<?php

define('SUPPORT_URL','https://webprojectlab.ru/');

$index_list   = array();
$index_list[] = 'product.model';
$index_list[] = 'url_alias.query';
$index_list[] = 'url_alias.keyword';

$action = (!empty($_REQUEST['action'])) ? $_REQUEST['action'] : '';

if(file_exists('./config.php')) {
  require_once './config.php';
  
  foreach($index_list as &$item) {
    $item = DB_PREFIX . $item;
  }
}
else {

  die("Отмена: config.php не найден!");
}

if(!$db = turbo_db_connect()) {
  die("Не удается подключиться к БД - Проверьте Настройки");
}

?>
<!DOCTYPE html>
<html lang="ru">
<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Opencart Ускоритель</title>
    <link href="//netdna.bootstrapcdn.com/bootstrap/3.0.2/css/bootstrap.min.css" rel="stylesheet">
</head>
<body>
    <a href="<?php echo SUPPORT_URL; ?>"><img style="position: absolute; top: 0; right: 0; border: 0;" src="https://webprojectlab.ru/images/right_ribbon_red.png" alt="Support from Web Project Lab"></a>
    <br>
    <div class="container">
        <div class="well">

      <h2>Opencart Ускоритель</h2>

      <p>
        Этот скрипт произведет ускорение производительности OpenCart, a в частности:<br>
        <ul>
          <li>Сконвертирует систему храния БД MySQL из MyISAM в InnoDB</li>
          <li>Добавит индексы для всех внешних ключей</li>
          <li>И многое другое...</li>
        </ul>
        <strong>Приемчание:</strong><br>
        <ul>
          <li>Этот скрипт должен быть удален сразу же после использования</li>
          <li>Этот скрипт необходимо будет запустить после обновления OpenCart</li>
        </ul>
      </p>
    </div>

    <div class="panel panel-primary">
      <div class="panel-heading">
        <h3 class="panel-title">Доступные опции</h3>
      </div>
      <div class="panel-body">
        <a href="turbo.php?action=engine" class="btn btn-success btn-lg" onclick="return confirm('Вы уверены, что хотите конвертировать таблицы базы данных OpenCart из MyISAM в InnoDB?');">Конвертировать БД</a><br><br>
        <a href="turbo.php?action=indexes" class="btn btn-success btn-lg" onclick="return confirm('Вы уверены, что хотите добавить индексы таблиц базы данных OpenCart?');">Добавить индексы БД</a>
      </div>
    </div>

        <div class="panel panel-default">
            <div class="panel-heading">
                <h3 class="panel-title">Результат</h3>
            </div>
            <div class="panel-body">
                <p><?php
                    ob_start();
                        switch($action) {
                        case 'engine':
                            turbo_switch_engine();
                                break;
                                case 'indexes':
                            turbo_table_indexes();
                                break;
                                case 'delete':
                                // Пока ничего
                                break;
                                default:
                                // Пока ничего
                                break;
                        }
                    ob_end_flush();
                ?></p>
            </div>
        </div>
    </div>
<script src="//netdna.bootstrapcdn.com/bootstrap/3.0.2/js/bootstrap.min.js"></script>
</body>
</html>
<?php

function turbo_table_indexes() {
  global $db, $index_list;

  $tables = turbo_get_tables(true);
  if($tables && count($tables) > 0) {

    turbo_log("Добавление индексов для таблиц");

    // Цикл по таблицам
    foreach($tables as $table_name => $table) {

      // Цикл по столбцам
      foreach($table['columns'] as $column_name => $column) {

        $has_index   = false;
        $needs_index = false;

        // Нужен ли этот столбец индекса?
        if(substr($column_name, -3) == '_id') {
          // Столбец заканчивается на «_id»
          $needs_index = true;
        }
        elseif(in_array($table_name.'.'.$column_name, $index_list)) {
          // Эта колонка существует в ручном списке индекса
          $needs_index = true;
        }

        // Цикл через индексы для этого столбца определит, имеется он или нет
        if($column['indexes'] && !empty($column['indexes'])) {

          foreach($column['indexes'] as $index) {

            if($index['position'] == 1) {
              // Этот столбец присутствует в первой позиции в индексе
              $has_index = true;
            }
          }
        }

        if(!$has_index && $needs_index) {
          // Не имеет индекса и нуждается в индексации
          $sql = "ALTER TABLE `{$table_name}` ADD INDEX (  `{$column_name}` )";
          if($output = $db->query($sql)) {
            turbo_log("{$table_name}.{$column_name} - Индекс добавлен",'success','УСПЕХ');
          }
          else {
            turbo_log("{$table_name}.{$column_name} - Не удалось добавить индекс - ".$db->error,'danger','ОШИБКА');
          }
        }
        elseif($needs_index) {
          // Уже имеет индекс
          turbo_log("{$table_name}.{$column_name} - Индекс уже добавлен",'info','ИНФО');
        }
      }
    }

  }
  else {
    turbo_log("Отмена",'danger','ОШИБКА');
  }
}

function turbo_switch_engine() {
  global $db;

  $tables = turbo_get_tables();
  if($tables && count($tables) > 0) {

    turbo_log("Переключения таблиц БД");

    foreach ($tables as $table_name => $table) {

      if($table['engine'] != 'InnoDB') {

        $sql = "ALTER TABLE `{$table_name}` ENGINE = INNODB";
        if($rs = $db->query($sql)) {
          turbo_log("{$table_name} Преобразовано из {$table['engine']} в InnoDB",'success','УСПЕХ');
        }
        else {
          turbo_log("{$table_name} Не удалось переключить - ".$db->error,'danger','ОШИБКА');
        }
      }
      else {
        turbo_log("{$table_name} Уже в формате InnoDB",'info','ПРОПУСК');
      }
    }
  }
  else {
    turbo_log("Aborting",'danger','ОШИБКА');
  }
}


function turbo_get_tables($getindexes=false) {
  global $db;
  $tables = false;
  $sql = "SELECT * FROM INFORMATION_SCHEMA.TABLES WHERE TABLE_SCHEMA LIKE '".DB_DATABASE."'";
  if($rs = $db->query($sql)) {

    if($rs->num_rows > 0) {
      // Table list loaded
      turbo_log("{$rs->num_rows} Таблиц Найдено");
      $tables = array();
      while ($row = $rs->fetch_assoc()) {

        $table               = array();
        $table['name']       = $row['TABLE_NAME'];
        $table['engine']     = $row['ENGINE'];
        $table['columns']    = false;

        if($getindexes) {

          // Сначала получаем индексы
          $sqli = "SELECT *
                  FROM INFORMATION_SCHEMA.STATISTICS
                  WHERE TABLE_SCHEMA LIKE '".DB_DATABASE."'
                  AND TABLE_NAME LIKE '".$table['name']."'";
          $table['indexes'] = array();
          if($rsi = $db->query($sqli)) {

            while($indexes = $rsi->fetch_assoc()) {

              $index             = array();
              $index['name']     = $indexes['COLUMN_NAME'];
              $index['key']      = $indexes['INDEX_NAME'];
              $index['unique']   = ($indexes['NON_UNIQUE'] == 1) ? false : true; // Логика инверсии
              $index['position'] = $indexes['SEQ_IN_INDEX'];

              if(!isset($table['indexes'][$index['name']])) {
                $table['indexes'][$index['name']] = array();
              }
              $table['indexes'][$index['name']][] = $index;
            }
          }

          // Получаем столбцы
          $sqlc = "SELECT *
                  FROM INFORMATION_SCHEMA.COLUMNS
                  WHERE TABLE_SCHEMA LIKE '".DB_DATABASE."'
                  AND TABLE_NAME LIKE '".$table['name']."'";

          if($rsc = $db->query($sqlc)) {

            $table['columns'] = array();
            while($columns = $rsc->fetch_assoc()) {

              $column            = array();
              $column['name']    = $columns['COLUMN_NAME'];
              $column['type']    = $columns['DATA_TYPE'];
              $column['indexes'] = false;

              if(isset($table['indexes'][$column['name']])) {
                // Если есть какие-либо индексы в этой колонке, добавляем в массив
                $column['indexes'] = $table['indexes'][$column['name']];
              }
              $table['columns'][$column['name']] = $column;
            }
          }
          else {
            turbo_log("Нет Стобцов в Таблице БД {$table['name']}",'danger','ОШИБКА');
          }
        }
        $tables[$table['name']] = $table;
      }
    }
    else {
      // Если не найдены таблицы
      turbo_log("Не Найдено таблиц в БД",'danger','Ошибка');
    }

  }
  else {
    turbo_log("Ошибка: Не Удается Получить Список Таблиц БД");
  }
  return $tables;
}



function turbo_log($input,$type='default',$label='') {

  if($label) {
    echo '<span class="label label-'.$type.'">'.$label.'</span> ';
  }
  echo $input."<br>";
  turbo_flush_buffers();
}

function turbo_flush_buffers() {
  ob_end_flush();
  ob_flush();
  flush();
  ob_start();
}

/**
 * Подключение к базе данных с помощью параметров конфигурации
 * @return MySQLi Объект подключения
 */
function turbo_db_connect() {
  $db = new mysqli(DB_HOSTNAME, DB_USERNAME, DB_PASSWORD, DB_DATABASE);
  return $db;
}

/* Конец файла */